package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.PaymentTemplateService;
import com.gxwebsoft.shop.entity.PaymentTemplate;
import com.gxwebsoft.shop.param.PaymentTemplateParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商城支付模板记录表控制器
 *
 * @author 科技小王子
 * @since 2022-12-09 13:59:38
 */
@Api(tags = "商城支付模板记录表管理")
@RestController
@RequestMapping("/api/shop/payment-template")
public class PaymentTemplateController extends BaseController {
    @Resource
    private PaymentTemplateService paymentTemplateService;

    @PreAuthorize("hasAuthority('shop:paymentTemplate:list')")
    @OperationLog
    @ApiOperation("分页查询商城支付模板记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<PaymentTemplate>> page(PaymentTemplateParam param) {
        PageParam<PaymentTemplate, PaymentTemplateParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(paymentTemplateService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(paymentTemplateService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:list')")
    @OperationLog
    @ApiOperation("查询全部商城支付模板记录表")
    @GetMapping()
    public ApiResult<List<PaymentTemplate>> list(PaymentTemplateParam param) {
        PageParam<PaymentTemplate, PaymentTemplateParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(paymentTemplateService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(paymentTemplateService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:list')")
    @OperationLog
    @ApiOperation("根据id查询商城支付模板记录表")
    @GetMapping("/{id}")
    public ApiResult<PaymentTemplate> get(@PathVariable("id") Integer id) {
        return success(paymentTemplateService.getById(id));
        // 使用关联查询
        //return success(paymentTemplateService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:save')")
    @OperationLog
    @ApiOperation("添加商城支付模板记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody PaymentTemplate paymentTemplate) {
        if (paymentTemplateService.save(paymentTemplate)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:update')")
    @OperationLog
    @ApiOperation("修改商城支付模板记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody PaymentTemplate paymentTemplate) {
        if (paymentTemplateService.updateById(paymentTemplate)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:remove')")
    @OperationLog
    @ApiOperation("删除商城支付模板记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (paymentTemplateService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:save')")
    @OperationLog
    @ApiOperation("批量添加商城支付模板记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<PaymentTemplate> list) {
        if (paymentTemplateService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:update')")
    @OperationLog
    @ApiOperation("批量修改商城支付模板记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<PaymentTemplate> batchParam) {
        if (batchParam.update(paymentTemplateService, "template_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTemplate:remove')")
    @OperationLog
    @ApiOperation("批量删除商城支付模板记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (paymentTemplateService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
